﻿import mx.managers.DepthManager;
import mx.remoting.debug.NetDebug;
import mx.remoting.*;
import mx.rpc.*;
import styles.*;
class Area_Admin extends MovieClip{
	var gatewayUrl:String;
	var admin_service:Service;
	var pc:PendingCall;
	var result_msg:String;
	var area_list:Object;
	var areas_retrieved:Boolean;
	var hotel_arr:Object;
	var target_clip:MovieClip;
	var cur_area:Number;
	var txt_format:TextFormat;
	var pen_mc:MovieClip;
	var active:Boolean;
	var text_width:Number;
	var text_height:Number;
	var line_color:Number;
	var triplist_arr:Object;
	var triplist_loaded:Boolean;
	var page_info:Array;
	
	function Area_Admin(gatewayUrl:String, service:String){
		NetDebug.initialize();
		this.gatewayUrl = gatewayUrl;
		this.admin_service = new Service(this.gatewayUrl, null, service, null , null);
		this.areas_retrieved = false;
		this.txt_format = new TextFormat();
		this.txt_format.font = "Tahoma";
		this.txt_format.size = 10;
		this.text_width = 70;
		this.text_height = 15;
		this.line_color = 0xFF0000;
		this.triplist_loaded = false;
		this.active = false;
		this.page_info = new Array();

	}
	
	function populate_list_component(area_list:mx.controls.List){
		if(!this.areas_retrieved && this.area_list != undefined){
			for(var i:Number = 0; i < this.area_list.length; i++){
				area_list.addItem({label:this.area_list[i].value, data:this.area_list[i].id});
			}
		this.areas_retrieved = true;
		}
	}
	
	function get_orientation_by_id(id:Number):String{
		for(var i:Number = 0; i < this.area_list.length; i++){
			if(id == this.area_list[i].id)
				return this.area_list[i].paper_format;
		}
	}
	
	function validate(){
		for(var i:Number = 0; i < this.hotel_arr.length; i++){
			if(this.hotel_arr[i].hotel_mc.hotel_label.text.length == 0){
				this.hotel_arr[i].hotel_mc.hotel_label.backgroundColor = 0xFF0000;
				return false;
			}else{
				this.hotel_arr[i].hotel_mc.hotel_label.backgroundColor = 0xFFFFFF;
			}
		}
		return true;
	}
	
	function clear(){
		for(var i:Number = 0; i < this.hotel_arr.length; i++){
			this.delete_hotel(i);
		}
		this.hotel_arr = new Object;
	}
	
	function delete_hotel(i){
		this.hotel_arr[i].hotel_mc.removeMovieClip();
		this.hotel_arr[i].marker_mc.removeMovieClip();
	}
	
	function create_hotel(){
		if(this.validate()){
			var tmp:Object = new Object;
			tmp.x_pos 			= 10;
			tmp.y_pos 			= 10;
			tmp.marker_x 		= 20;
			tmp.marker_y 		= 20;
			tmp.name_req_unique = "";
			tmp.address 		= "";
			tmp.pickup_time 	= "";
			var nbr:Number 	= this.hotel_arr.push(tmp) - 1;
			this.hotel_to_stage(this.hotel_arr[nbr], nbr);
			this.marker_to_stage(this.hotel_arr[nbr], nbr);
		}
	}
	
	function marker_to_stage(obj:Object, h_nbr:Number, offset_y:Number){
		if(offset_y == undefined)
			offset_y = 0;
		var cur_marker:MovieClip = this.target_clip.createChildAtDepth("hotel_marker", DepthManager.kTop);
		cur_marker._x = obj.marker_x;
		cur_marker._y = parseInt(obj.marker_y) + offset_y;
		obj.marker_mc = cur_marker;
	}
	
	function on_enter_frame(){
		if(this.active){
			this.pen_mc.clear();
			this.pen_mc.lineStyle(1, this.line_color, 100);
			for(var i:Number = 0; i < this.hotel_arr.length; i++){
				
				this.hotel_arr[i].hotel_name.setTextFormat(this.txt_format);
				this.hotel_arr[i].hotel_address.setTextFormat(this.txt_format);
				this.hotel_arr[i].hotel_pickup_time.setTextFormat(this.txt_format);
				
				var lineto_x:Number = 0;
				var lineto_y:Number = 0;
				
				if(this.hotel_arr[i].hotel_mc._x + this.hotel_arr[i].hotel_mc._width < this.hotel_arr[i].marker_mc._x)
					lineto_x = this.hotel_arr[i].hotel_mc._x + this.text_width;
				else
					lineto_x = this.hotel_arr[i].hotel_mc._x;
					
				if(this.hotel_arr[i].hotel_mc._y + this.text_height < this.hotel_arr[i].marker_mc._y)
					lineto_y = this.hotel_arr[i].hotel_mc._y + this.text_height;
				else
					lineto_y = this.hotel_arr[i].hotel_mc._y;
					
				this.pen_mc.moveTo(this.hotel_arr[i].marker_mc._x, this.hotel_arr[i].marker_mc._y);
				this.pen_mc.lineTo(lineto_x, lineto_y);
			}
		}
	}
	
	function hotel_to_stage(obj:Object, h_nbr:Number, offset_y:Number){
		if(offset_y == undefined)
			offset_y = 0;
		var to_clip:Object = new Object();
		to_clip.my_number = h_nbr;
		var cur_hot:MovieClip = this.target_clip.createChildAtDepth("hotel_dragger_template", DepthManager.kTop, to_clip);
		var cur_text:TextField = cur_hot.createTextField("hotel_label", cur_hot.getNextHighestDepth(), 0, 0, this.text_width, this.text_height);
		cur_text.border = true;
		cur_text.type = "input";
		cur_hot._x = obj.x_pos;
		cur_hot._y = parseInt(obj.y_pos) + offset_y;
		cur_text.text = obj.name_req_unique;
		cur_text.setTextFormat(this.txt_format);
		obj.hotel_name = cur_text;
		obj.hotel_mc = cur_hot;
		
		var cur_text:TextField = cur_hot.createTextField("hotel_address", cur_hot.getNextHighestDepth(), 0, -this.text_height-2, this.text_width+50, this.text_height);
		cur_text.border = true;
		cur_text.type = "input";
		cur_text.text = obj.address;
		cur_text.setTextFormat(this.txt_format);
		cur_text._visible = false;
		obj.hotel_address = cur_text;
		
		var cur_text:TextField = cur_hot.createTextField("hotel_pickup_time", cur_hot.getNextHighestDepth(), 0, -(this.text_height*2)-4, this.text_width, this.text_height);
		cur_text.border = true;
		cur_text.type = "input";
		cur_text.text = obj.pickup_time;
		cur_text.setTextFormat(this.txt_format);
		cur_text._visible = false;
		obj.hotel_pickup_time = cur_text;
	}
	
	///////////////////
	function load_areas(){
		this.pc = this.admin_service.load_areas();
		pc.responder = new RelayResponder(this, "handle_load_areas", "load_areas_error");
	}
	
	function handle_load_areas(re:ResultEvent){
		this.area_list = re.result;
	}
	
	function load_areas_error(fe:FaultEvent){this.result_msg = "areas_missing";}
	///////////////////
	function save_hotels(){
		if(this.validate()){
			for(var i:Number = 0; i < this.hotel_arr.length; i++){
				if(this.hotel_arr[i].hotel_mc._name != undefined){
					this.hotel_arr[i].x_pos = this.hotel_arr[i].hotel_mc._x;
					this.hotel_arr[i].y_pos = this.hotel_arr[i].hotel_mc._y;
					this.hotel_arr[i].marker_x = this.hotel_arr[i].marker_mc._x;
					this.hotel_arr[i].marker_y = this.hotel_arr[i].marker_mc._y;
					this.hotel_arr[i].tbl_area = this.cur_area;
					this.hotel_arr[i].name_req_unique = this.hotel_arr[i].hotel_mc.hotel_label.text;
					this.hotel_arr[i].address = this.hotel_arr[i].hotel_mc.hotel_address.text;
					this.hotel_arr[i].pickup_time = this.hotel_arr[i].hotel_mc.hotel_pickup_time.text;
				}else{
					this.hotel_arr[i] = undefined;
				}
			}
			this.pc = this.admin_service.save_hotels(this.hotel_arr, this.cur_area);
			pc.responder = new RelayResponder(this, "handle_save_hotels", "save_hotels_error");
		}
	}
	
	function handle_save_hotels(re:ResultEvent){
		this.result_msg = String(re.result);
	}
	
	function save_hotels_error(fe:FaultEvent){this.result_msg = "save_failed";}
	///////////////////
	function load_hotels(area:Number, target_clip:MovieClip){
		this.active = true;
		this.clear();
		this.cur_area = area;
		this.target_clip = target_clip;
		this.pen_mc = this.target_clip.createEmptyMovieClip("pen_mc", 1);
		this.pen_mc.lineStyle(1, this.line_color, 100);
		this.pc = this.admin_service.load_hotels(area);
		pc.responder = new RelayResponder(this, "handle_load_hotels", "load_hotels_error");
	}
	
	function handle_load_hotels(re:ResultEvent){
		this.hotel_arr = re.result;
		for(var i:Number = 0; i < this.hotel_arr.length; i++){
			this.hotel_to_stage(this.hotel_arr[i], i);
			this.marker_to_stage(this.hotel_arr[i], i);
		}
	}
	
	function load_hotels_error(fe:FaultEvent){this.result_msg = "hotels_missing";}
	///////////////////
	function create_triplist(date:String, target_clip:MovieClip){
		
		this.txt_format = new TextFormat();
		this.txt_format.font = "Tahoma";
		this.txt_format.size = 8;
		
		this.target_clip = target_clip;
		this.pen_mc = this.target_clip.createEmptyMovieClip("pen_mc", 1);
		this.line_color = 0x000000;
		this.pen_mc.lineStyle(1, this.line_color, 100);
		this.pc = this.admin_service.create_triplist(date);
		pc.responder = new RelayResponder(this, "handle_create_triplist", "create_triplist_error");
	}
	
	function handle_create_triplist(re:ResultEvent){
		triplist_arr = re.result;
		
		this.triplist_arr = this.remove_undefined(triplist_arr);
		
		this.hotel_arr = new Array();
		this.triplist_loaded = true;
		this.active = true;
		var cur_y:Number = 0;
		var margin_y:Number = 0;
		for(var i:Number = 0; i < this.triplist_arr.length; i++){
			
			var orient:String = this.triplist_arr[i].paper_format;
			
			//trace(orient);
			
			if(i == 1){
				margin_y = 200;
			}
			
			var cur_area:MovieClip = this.target_clip.createChildAtDepth("hotel_dragger_template", DepthManager.kTop);
			cur_area._y = cur_y + margin_y;
			cur_area.loadMovie("areas/area"+this.triplist_arr[i].id+".swf");
			var pickups:Object = this.triplist_arr[i].pickups;
			for(var j:Number = 0; j < pickups.length; j++){
				this.hotel_to_stage(pickups[j].db_hotel, i+j, cur_y+margin_y);
				this.marker_to_stage(pickups[j].db_hotel, i+j, cur_y+margin_y);
				this.hotel_arr.push(pickups[j].db_hotel);
			}
			
			if(orient == "a4_portrait"){
				this.add_page(0, cur_y, 532, cur_y+800);
				cur_y += 600+margin_y;
			}else if(orient == "a4_landscape"){
				this.add_page(0, cur_y, 800, cur_y+532);
				cur_y += 400+margin_y;
			}
		}
		//cur_y += 600;
		//this.create_triplist_list(cur_y + margin_y);
		
	}
	
	function create_triplist_error(fe:FaultEvent){this.result_msg = "hotels_missing";}
	///////////////////
	
	function add_page(x_s:Number, y_s:Number, x_e:Number, y_e:Number){
		var pObj:Object = new Object();
		pObj.xMin = x_s;
		pObj.yMin = y_s;
		pObj.xMax = x_e;
		pObj.yMax = y_e;
		this.page_info.push(pObj);
	}
	
	function remove_undefined(arr:Object):Array{
		var rarr:Array = new Array();
		for(var i:Number = 0; i < arr.length; i++){
			if(arr[i] != undefined){
				rarr.push(arr[i]);
			}
		}
		return rarr;
	}
	
	/*
	function create_triplist_list(start_y:Number){
		var margin_x:Number = 30;
		//var txt_height:Number = 13;
		var column_width:Number = 90;
		var area_head_style:TextFormat = CommonStyles.tahoma12bold();
		var head_style:TextFormat = CommonStyles.tahoma10bold();
		for(var i:Number = 0; i < this.triplist_arr.length; i++){

			var incr:Number = this.create_text_field(this.triplist_arr[i].value,"txt_"+i,margin_x,start_y,area_head_style);
			start_y += incr;
			
			this.create_text_field("Customer",	"cushead_txt_"+i,margin_x,					start_y,head_style);
			this.create_text_field("Hotel",		"hothead_txt_"+i,margin_x+column_width,		start_y,head_style);
			this.create_text_field("Activity",	"acthead_txt_"+i,margin_x+(column_width*2),start_y,head_style);
			var incr:Number = this.create_text_field("Employee","emphead_txt_"+i,margin_x+(column_width*3),start_y,head_style);
			start_y += incr;
			
			var pickups:Object = this.triplist_arr[i].pickups;
			for(var j:Number = 0; j < pickups.length; j++){
				this.create_text_field(pickups[j].db_customer.name_req,		"txt_"+i+"_"+j,margin_x,					start_y);
				this.create_text_field(pickups[j].db_hotel.name_req_unique,	"txt_"+i+"_"+j,margin_x+column_width,		start_y);
				this.create_text_field(pickups[j].tbl_activity,					"txt_"+i+"_"+j,margin_x+(column_width*2),	start_y);
				var incr:Number = this.create_text_field(pickups[j].db_employee,					"txt_"+i+"_"+j,margin_x+(column_width*3),	start_y);
				start_y += incr;
			}
			
			start_y += incr;
		}
	}
	*/
	
	function create_text_field(text_content:String, text_name:String, pos_x:Number, pos_y:Number, txt_format:TextFormat):Number{
		
		if(txt_format == undefined){
			txt_format = this.txt_format;
		}
		var metrics:Object = txt_format.getTextExtent(text_content);
		var cur_text:TextField = this.target_clip.createTextField(text_name, this.target_clip.getNextHighestDepth(), pos_x, pos_y, metrics.textFieldWidth, metrics.textFieldHeight);
		cur_text.text = text_content;
		cur_text.setTextFormat(txt_format);
		cur_text.background = false;
		return metrics.textFieldHeight; 
	}
}