﻿import reefling.classes.util.*
class RespCirc{
	
	var fitness:Number;		//general fitness level that affects performance, is between 1 and 3.5
	var lungVol:Number;		//the max volume of the lungs in litres
	var lungLevel:Number;		//the current volume of air in the lungs
	var carbonVol:Number;		//the amount of CO2 in the system
	var carbonLimit:Number;	//the amount of CO2 the system can handle before involuntary breathing
	var exertionLev:Number;	//the current level of exertion, affects CO2 creation
	var exertionInc:Number;	//speed of exertioncreation
	var exertionDec:Number;	//speed of exertiondecline when idle
	var working:Boolean;		//are the muscles working?
	var breatheOut:Boolean;
	var breatheIn:Boolean;
	
	function RespCirc(fit:Number){
		this.fitness 		= fit;
		this.lungVol 		= fit * 2;
		this.carbonLimit 	= fit * 1.5;
		this.exertionInc 	= 0.1 / fit;
		this.exertionDec 	= fit / 20;
		
		this.carbonVol 		= 0;
		this.exertionLev 	= 0;
		this.working 		= false;
		this.breatheOut 	= false;
		this.breatheIn  	= false;
		this.lungLevel		= this.lungVol/2;
	}
	
	/*
	function changeFitness(fit:Number){
		this.fitness 		= fit;
		this.carbonLimit 	= fit * 1.5;
		this.exertionInc 	= 1 / fit;
		this.exertionDec 	= fit / 2;
	}
	*/
	
	function autoBreathe(){
		if(this.lungLevel <= this.lungVol/2){
			this.breatheIn = true;
			this.breatheOut = false;
		} else {
			this.breatheOut = true;
			this.breatheIn = false;
		}
	}
	
	function updateMe(){
		if(this.working){
			this.exertionLev += this.exertionInc;
		}else if(this.exertionLev > 0){
			this.exertionLev -= this.exertionDec;
			this.exertionLev = HSMath.upToZero(this.exertionLev);
		}
		
		if(this.carbonVol >= this.carbonLimit){
			this.autoBreathe();
		}
		
		if(this.breatheIn){
			this.lungVol += this.exertionLev + 0.01;
			this.carbonVol -= this.fitness / this.exertionLev;
		}
		
		if(this.breatheOut){
			this.lungVol -= this.exertionLev + 0.01;
		}
		
		this.carbonVol += this.exertionLev + 0.01;
		
		
		
	}
}