﻿import mx.remoting.debug.NetDebug;
import mx.remoting.*;
import mx.rpc.*;
import AsClasses.util.*;
class BilatChat{
	
	private var chatTimer:TimeControl;
	private var chatId:String;
	private var gatewayUrl:String;
	private var chatService:Service;
	private var pc:PendingCall;
	private var identity:Number;
	private var chatEvents:Array;
	private var resultEvents:Array;
	
	public var workIndicator:MovieClip;
	public var chatStatus:Number;
	public var msgQ:Boolean;
	public var chatMsg:String;
	public var chatInfo:Object;
	public var p_mc:MovieClip;
	public var resultMsg:String;
	public var eventMsg:String;
	
	static var interv:Number = 5000;
	
	function BilatChat(gatewayUrl:String, service:String, p_mc:MovieClip, event_msg:Array, result_msg:Array, indicator:MovieClip){
		NetDebug.initialize();
		this.workIndicator = indicator;
		this.chatEvents = event_msg;
		this.resultEvents = result_msg;
		this.msgQ = false;
		this.identity = 0;
		this.chatStatus = 0;
		this.chatTimer = new TimeControl(BilatChat.interv);
		this.gatewayUrl = gatewayUrl;
		this.chatService = new Service(this.gatewayUrl, null, service, null , null);
		this.chatInfo = new Object();
		this.resultMsg = "";
		this.eventMsg = "";
		this.p_mc = p_mc;
		this.updateChat();
	}
	
	function popChatInfo(arr:Array){
		this.chatInfo.member1_id = arr[0].member1_id;
		this.chatInfo.member2_id = arr[0].member2_id;
		this.chatInfo.member1_name = arr[0].member1_name;
		this.chatInfo.member2_name = arr[0].member2_name;
	}
	
	function resetChat(){
		this.chatStatus = 0;
		this.identity = 0;
		this.chatTimer.setInterval(BilatChat.interv);
	}
	
	function setChatStatus(chatStatus:Number){
		this.chatStatus = chatStatus;
	}
	
	function getMyName(){
		if(this.identity == 1)
			return this.chatInfo.member1_name;
		else
			return this.chatInfo.member2_name;
	}
	
	function getPartnerName(){
		if(this.identity == 1)
			return this.chatInfo.member2_name;
		else
			return this.chatInfo.member1_name;
	}
	
	//-------- send msg ----------------
	function sendMsg(msg:String){
		msg = StringManip.space2nsp(msg);
		this.pc = this.chatService.send_msg(msg, this.identity, this.chatId);
		pc.responder = new RelayResponder(this, "handleMsg", "handleMsgError");
		//trace(member2_name);
	}
	function handleMsg(re:ResultEvent){this.resultMsg = resultEvents[1];}
	function handleMsgError(fe:FaultEvent){this.resultMsg = resultEvents[2];}
	/////////////////////////////////////////
	//-------- request chat ----------------
	function requestChat(member2_name:String){
		this.pc = this.chatService.request(member2_name);
		pc.responder = new RelayResponder(this, "handleReq", "handleReqError");
		//trace(member2_name);
	}
	function handleReq(re:ResultEvent){
		this.workIndicator.idle();
		if(String(re.result) == "no_member")
			this.eventMsg = this.chatEvents[0];
		else if(String(re.result) == "member_not_online")
			this.eventMsg = this.chatEvents[1];
		else if(String(re.result) == "member_block")
			this.eventMsg = this.chatEvents[2];
		else if(String(re.result) == "age_block")
			this.eventMsg = this.chatEvents[14];
		else if(String(re.result) == "self")
			this.eventMsg = this.chatEvents[13];
		else{
			this.chatId = String(re.result);
			this.eventMsg = this.chatEvents[3];
			this.identity = 1;
			this.chatStatus = 1;
		}
	}
	function handleReqError(fe:FaultEvent){this.resultMsg = resultEvents[3];}
	/////////////////////////////////////////
	//-------- destroy chat ----------------
	function destroyChat(){
		this.workIndicator.work();
		this.pc = this.chatService.destroy_chat(this.chatId);
		pc.responder = new RelayResponder(this, "handleDestroy", "handleDestroyError");
	}
	function handleDestroy(re:ResultEvent){
		this.workIndicator.idle();
		this.eventMsg = this.chatEvents[4];
		this.resetChat();
	}
	function handleDestroyError(fe:FaultEvent){this.resultMsg = resultEvents[4];}
	/////////////////////////////////////////
	//-------- accept deny ----------------
	function acceptDeny(answer:Number, reason:String){
		this.workIndicator.work();
		if(!answer)
			this.resetChat();
		else{
			this.chatStatus = 2;
			this.identity = 2;
			this.chatTimer.setInterval(BilatChat.interv);
		}
		
		reason = StringManip.space2nsp(reason);
		this.pc = this.chatService.accept_deny(answer, this.chatId, reason);
		pc.responder = new RelayResponder(this, "handleAcceptDeny", "handleAcceptDenyError");
	}
	function handleAcceptDeny(re:ResultEvent){this.eventMsg = this.chatEvents[12];this.workIndicator.idle();}
	function handleAcceptDenyError(fe:FaultEvent){this.resultMsg = resultEvents[5];}
	/////////////////////////////////////////
	//-------- poll accept ----------------
	function handlePoll_accept(re:ResultEvent){
		this.workIndicator.idle();
		var arr:Array  = re.result.items;
		if(Number(arr[0].active) == 0){
			this.eventMsg = this.chatEvents[5]+StringManip.nsp2space(arr[0].decline_reason);
			this.resetChat();
			this.destroyChat();
		}else if(Number(arr[0].active) == 2){
			this.chatStatus = 2;
			this.popChatInfo(arr);
			this.chatTimer.setInterval(BilatChat.interv);
			this.eventMsg = arr[0].member2_name+this.chatEvents[6];
		}else if(!Number(arr[0].window_open)){
			this.eventMsg = this.chatEvents[7];
			this.chatTimer.setInterval(BilatChat.interv);
		}else
			this.eventMsg = this.chatEvents[8];
	}
	function handlePoll_acceptError(fe:FaultEvent){this.resultMsg = resultEvents[6];}
	/////////////////////////////////////////
	function doChat(){
		if(this.chatTimer.checkInterval(getTimer())){
			this.updateChat();
			this.workIndicator.work();
		}
	}
	/////////////////////////////////////////
	function updateChat(){
		if(this.chatStatus == 0){
			this.pc = this.chatService.poll_request();
			pc.responder = new RelayResponder(this, "handlePollReq", "handlePollReqError");
		}
		
		if(this.chatStatus == 1){
			this.pc = this.chatService.poll_accept(this.chatId);
			pc.responder = new RelayResponder(this, "handlePoll_accept", "handlePoll_acceptError");
		}
		
		if(this.chatStatus == 2){
			this.pc = this.chatService.poll_msg(this.identity, this.chatId);
			pc.responder = new RelayResponder(this, "handlePollMsg", "handlePollMsgError");
		}
	}
	
	//---------- poll requests handling-----------
	function handlePollReq(re:ResultEvent){
		this.workIndicator.idle();
		if(String(re.result) == "no_session")
			this.eventMsg = this.chatEvents[9];
		else if(String(re.result) == "no_requests"){
			this.resultMsg = this.resultEvents[0];
		}else{
			var obj:Object = re.result;
			this.chatId = String(obj.id);
			this.chatInfo = obj;
			this.chatStatus = -1;
			this.eventMsg = this.chatInfo.member1_name + this.chatEvents[10];
		}
	}
	
	function handlePollReqError(fe:FaultEvent){this.resultMsg = this.resultEvents[0];}
	/////////////////////////////////////////
	//---------- poll message handling-----------
	function handlePollMsg(re:ResultEvent){
		this.workIndicator.idle();
		var arr:Array  = re.result.items;
		if(String(re.result) == "quit"){
			this.eventMsg = this.getPartnerName() + this.chatEvents[11];
			this.resetChat();
		}else if(arr[0].msg.length > 0){
			this.chatMsg = StringManip.nsp2space(arr[0].msg);
			this.msgQ = true;
		}
	}
	
	function handlePollMsgError(fe:FaultEvent){this.resultMsg = this.resultEvents[7];}
	/////////////////////////////////////////
}