﻿import reefling.classes.util.*
class Chain {
	
	var arr:Array;			//the array which will contain all the links
	//var pencil:MovieClip;
	var elast:Number;		//the elasticity of the chain
	var damp:Number;		//the damping of the chain
	var spacing:Number;	//spacing in pixels between the links
	
	function Chain(X:Number, Y:Number, n:Number, e:Number, d:Number, s:Number){
		this.arr 		= new Array(n);
		this.elast		= e;
		this.damp 		= d;
		this.spacing	= s;
		
		//---------- initiation -----------------
		//the top link is positioned
		var temp:ChainLink = new ChainLink(X, Y, damp, elast, 0);
		this.arr[0] = temp;
		//the middle links are positioned
		for(var i:Number = 1; i < this.arr.length - 1; i++){
			temp = new ChainLink(X, i*spacing, damp, elast, 1);
			this.arr[i] = temp;
		}
		//the end link is positioned
		var temp:ChainLink = new ChainLink(X, (this.arr.length - 1)*spacing, this.damp, this.elast, 2);
		this.arr[this.arr.length - 1] = temp;
		
		
		//------- linkage -----------------------
		//the hierachy is established
		this.arr[0].child = this.arr[1];
		
		for(var i:Number = 1; i < this.arr.length - 1; i++){
			this.arr[i].parent = this.arr[i-1];
			this.arr[i].child = this.arr[i+1];
		}
		
		this.arr[this.arr.length - 1].parent = this.arr[this.arr.length - 2];
		//----------------------------------------
		//the starting difference values are set
		for(var i:Number = 0; i < this.arr.length; i++){
			this.arr[i].setInitValues();
		}
	}
	
	//calculates the angle between two links to be able to rotate eventual attached movieclip
	function calcAngle(n1:Number, n2:Number):Number{
		var diff:V2D = HSMath.d2dif(this.arr[n1].pos, this.arr[n2].pos);
		var angle:Number = Math.atan(diff.y/diff.x);
		return angle;
	}
	
}