﻿import reefling.classes.util.*
import reefling.classes.ocean.*
class Repulsion{
	
	var limit:Number;
	var str:Number;
	var fadeStr:Number;
	var arr:Array;
	var transArr:Array;
	var bubbles:Bubbles;
	
	function Repulsion(l:Number, str:Number, fstr:Number){
		this.limit		= l;
		this.str		= str;
		this.fadeStr	= fstr;
		
	}
	
	function connectToBubbles(b:Bubbles){
		this.arr = b.arr;
		this.bubbles = b;
		this.transArr = new Array(this.arr.length);
		for(var i:Number = 0; i < this.arr.length; i++)
			this.transArr[i] = new V2D(0,0);
	}
	
	function affectBubbles(affX:Number, affY:Number){
		
		var affector:V2D = new V2D(affX, affY);
		
		for(var i:Number = 0; i < this.arr.length; i++){
			
			var affected:V2D = new V2D(this.arr[i].clip._x + (this.arr[i].clip._width/2), this.arr[i].clip._y + (this.arr[i].clip._height/2));
			var dist:Number = HSMath.d2abs(affector, affected);
			
			if(dist < this.limit && !this.bubbles.breatheInFlag){
				var dif:V2D = HSMath.d2dif(affector, affected);
				//var angle:Number = dif.getAngle();
				this.transArr[i].incScals((this.str * dif.x)/Math.pow(dist,this.fadeStr), 
										   (this.str * dif.y)/Math.pow(dist,this.fadeStr));
			} else if(dist > this.limit){
				this.transArr[i].divideScal(this.fadeStr);
			} else if(this.bubbles.breatheInFlag){
				this.transArr[i].set(0,0);
			}
			//trace(this.transArr[0].x);
			this.arr[i].startPosX += this.transArr[i].x;
			this.arr[i].clip._y   += this.transArr[i].y;
		}
	}
}