﻿import AsClasses.util.*				//general purpose supportclass for the imagescaling
class BannerClip extends MovieClip{
	var bkgClip:MovieClip;			//the backgroundclip
	var displayClip:MovieClip;		//the clip to display on top in case of event
	var initObj:Object;			//object containing the info to display
	var newBkg:MovieClip;			//the clip that will finally contain the image
	var propLoader:MovieClipLoader;
	var finishedLoading:Boolean;
	//we pass the clip that will contain the image, the clip that will display the info and the object
	//containing the info
	function BannerClip(bkg:MovieClip, display:MovieClip, initObj:Object){
		//local referencing
		this.bkgClip = bkg;
		this.displayClip = display;
		this.initObj = initObj;
		this.finishedLoading = false;
		//a loader for loading the background images
		this.propLoader = new MovieClipLoader();
		//listener to be invoked when the load is finished
		var propListener:Object = new Object();
		//cascading to enable access/connection in callback functions
		propListener.bkgClip = this.bkgClip;
		propListener.parent = this;
		propListener.displayClip = this.displayClip;
		//we add the listener
		this.propLoader.addListener(propListener);
		//we load the image
		this.propLoader.loadClip(initObj.imagePath, this.bkgClip);
		//when the image has finished loading
		propListener.onLoadInit = function(initClip){
			this.parent.finishedLoading = true;
			//we establish the relation again
			this.bkgClip = initClip;
			//we scale the image to fit the stage
			HSHelp.scaleToFitStageVertical(this.bkgClip);
			this.bkgClip._y = 0;
			//cascading to enable access/connection in callback functions
			this.bkgClip.displayClip = this.displayClip;
			//on each frame:
			this.bkgClip.onEnterFrame = function(){
				//if the flag is true we roll to the left
				if(_root.isRolling)
					this._x -= _root.rollSpeed;
				//if we roll out of the picture to the left we leapfrog to the rightmost position
				if(this._x < -this._width)
					this._x += _root.xWidth;
			}
			this.bkgClip.onRollOver = function(){
				//we stop the rolling
				_root.isRolling 						= false;
				//we move the display clip to the position of the current background image
				this.displayClip._x 					= this._x;
				this.displayClip._y 					= this._y;
				//we display the info
				this.displayClip.price_txt.text 		= initObj.property_price;
				this.displayClip.location_txt.text 		= "Loc.:"+initObj.property_location;
				//we scale the display clip to fit the background image
				this.displayClip.bkg_mc._width 			= this._width;
				this.displayClip.bkg_mc._height 		= this._height;
				//and finally we display the info clip
				this.displayClip._visible 				= true;
				
			}
			this.bkgClip.onRollOut = function(){
				//we start rolling again
				_root.isRolling = true;
				//we hide the info display
				this.displayClip._visible = false;
			}
			
			this.bkgClip.onRelease = function(){
				//we display a popup with info from a php script
				var url:String = "javascript:openpopup('"+_root.path+"propertysearch/detailHouse.php?pid="+initObj.property_id+"',800,470)";
				getURL(url);
			}
			//here we establish the relation to the bannerclip container
			this.parent.newBkg = this.bkgClip;
			//we hide the background image initially before all the images are loaded and placed in the
			//right place
			this.parent.newBkg._visible = false;
			//now the current bkg image is loaded so we increase the counter
			_root.numLoad++;
			
		}
	}
	
	function getProgrs():Number{
		var prog:Object = this.propLoader.getProgress(this.bkgClip);
		return prog.bytesLoaded / prog.bytesTotal;
		
	}
	function makeBorder(borderName:String, clipName:String){
		
		_root.createEmptyMovieClip(clipName, _root.getNextHighestDepth());
		_root.clipName.attachMovie(borderName, clipName, _root.getNextHighestDepth());
		_root.clipName._x = this.newBkg._x;
		trace(this.newBkg._x);
		
		_root.clipName.onEnterFrame = function(){
			//if the flag is true we roll to the left
			if(_root.isRolling)
				this._x -= _root.rollSpeed;
			//if we roll out of the picture to the left we leapfrog to the rightmost position
			if(this._x < -this._width)
				this._x += _root.xWidth;
		}
		
	}
	
}