﻿class HSShopMenuItem{
	var cont:MovieClip;			//the movieclip that contains this menuitem
	var info:String;				//the descriptive info for this item
	var childq:Number;				//does this item have any children, if so an expandbutton will show
	var parent:Object;				//the menu object that owns this item
	var child:MovieClip;			//the movieclip that will contain any submenues
	var headline:String;			//the name of the current item
	var txtformat:TextFormat;		//the textformat of the name
	var pic:String;				//the picture belonging to the item
	var code:String;				//the code for the current item
	var parentItem:HSMenuItem;		//the parent menuitem for this item
	var stock:Number;
	var expandBtnWidth:Number;
	
	function HSShopMenuItem(cont:MovieClip, txt:String, info:String, pic:String, 
	txtformat:TextFormat, childq:Number, stock:Number, parent:Object, price:Number, 
	code:String, fullname:String, weight:String){
		this.cont = cont;
		this.headline = txt;
		this.txtformat = new TextFormat();
		this.applyTextFormat(txtformat);
		this.expandBtnWidth = 24;
		
		while(this.headline.length * this.txtformat.size > 215){
			this.txtformat.size--;
		}
		
		this.cont.createTextField("txt", this.cont.getNextHighestDepth(), 25, 3, 132, 18);
		this.cont.txt.text = this.headline;
		this.cont.txt.setTextFormat(this.txtformat);
		this.cont.txt.selectable = false;
		
		this.info = info;
		this.pic = pic;
		this.childq = childq;
		this.parent = parent;
		this.stock = stock;
		
		var toBtn:Object = new Object();
		toBtn.pmenu = this.parent;
		toBtn.cmenu = this;
		toBtn.info = this.info;
		toBtn.pic = this.pic;
		toBtn.headline = fullname;
		toBtn.clip = _root;
		toBtn.id = this.parent.id;
		toBtn.price = price;
		toBtn.stock = stock;
		toBtn.code = code;
		toBtn.weight = weight;
		
		if(this.childq == 1){
			this.cont.createEmptyMovieClip("expandbtn", this.cont.getNextHighestDepth());
			this.cont.expandbtn.attachMovie("expandbutton", "expandbtn", this.cont.getNextHighestDepth(), toBtn);
			this.cont.createEmptyMovieClip("childmenu", this.cont.getNextHighestDepth());
			this.child = this.cont.childmenu;
			this.child._x = this.cont.expandbtn._x + expandBtnWidth;
			this.child._y = this.cont.expandbtn._y + this.cont.expandbtn._height;
		}
			
		if(this.info.length > 2 || this.pic.length > 2){
			if(this.info.length > 2)
				toBtn.startWith = "info";
			else
				toBtn.startWith = "pic";
			
			this.cont.createEmptyMovieClip("gobtn", this.cont.getNextHighestDepth());
			this.cont.gobtn.attachMovie("shopgobtn", "gobtn", this.cont.getNextHighestDepth(), toBtn);
			this.cont.gobtn._x = 132 + 24;
		}
	}
	
	function applyTextFormat(txtformat){
		this.txtformat.size = txtformat.size;
		this.txtformat.bold = txtformat.bold;
		this.txtformat.color = txtformat.color; 
		this.txtformat.font = txtformat.font;
	}
	
	function childReset(){
		this.cont.createEmptyMovieClip("childmenu", this.child.getDepth());
		this.child = this.cont.childmenu;
		this.child._x = this.cont.expandbtn._x + expandBtnWidth;
		this.child._y = this.cont.expandbtn._y + this.cont.expandbtn._height;
	}
	
	function goTo(x:Number, y:Number){
		this.cont._x = x;
		this.cont._y = y;

	}
}