﻿import reefling.classes.util.*
class NavInit{
	static function initVerticalScroll(scroller:MovieClip, scrollbkg:MovieClip){
		scroller.onPress = function(){
			this.startDrag(false, this._x, scrollbkg._y, this._x, scrollbkg._y + scrollbkg._height - this._height);
			//HSHelp.showDragCursor("mousedragger", true);
			HSHelp.setDrag("dragger_closed");
		}
		
		scroller.onRelease = function(){
			this.stopDrag();
			HSHelp.setDrag("mousedragger");
			//HSHelp.showDragCursor("mousedragger", false);
		}
		
		scroller.onReleaseOutside = function(){
			this.stopDrag();
			HSHelp.showDragCursor("mousedragger", false);
		}
		
		scroller.onRollOver = function(){
			HSHelp.showDragCursor("mousedragger", true);
		}
		
		scroller.onRollOut = function(){
			HSHelp.showDragCursor("mousedragger", false);
		}
	}
	
	static function initHorizontalScroll(scroller:MovieClip, scrollbkg:MovieClip){
		scroller.onPress = function(){
			this.startDrag(false, this._y, scrollbkg._x, this._y, scrollbkg._x + scrollbkg._width - this._width)
		}
		
		scroller.onRelease = function(){
			this.stopDrag();
		}
		
		scroller.onReleaseOutside = function(){
			this.stopDrag();
		}
	}
	
	
	static function initDrag(dragged:MovieClip, dragger:MovieClip){
		dragger.onPress = function(){
			dragged.swapDepths(dragged._parent.getNextHighestDepth());
			_root.mousedrag.swapDepths(_root.getNextHighestDepth());
			HSHelp.setDrag("dragger_closed");
			dragged.startDrag();
			
		}
		
		dragger.onRelease = function(){
			HSHelp.setDrag("mousedragger");
			dragged.stopDrag();
			
		}
		
		dragger.onReleaseOutside = function(){
			dragged.stopDrag();
		}
		
		dragger.onRollOver = function(){
			HSHelp.showDragCursor("mousedragger", true);
		}
		
		dragger.onRollOut = function(){
			HSHelp.showDragCursor("mousedragger", false);
		}
	}
	
	static function initScrollButton(button:Button, updown:String, scroller:HSScroll, speed:Number){
		if(updown == "up"){
			button.onPress = function(){
				scroller.speed = -speed;
			}
		}
		
		if(updown == "down"){
			button.onPress = function(){
				scroller.speed = speed;
			}
		}
		
		button.onRelease = function(){
			scroller.speed = 0;
		}
	}
	
	static function initLoader(loadObj:MovieClip, pBar_mc:MovieClip){
		pBar_mc.onEnterFrame = function() {
			var pctLoaded:Number = Math.floor(loadObj.getBytesLoaded() / loadObj.getBytesTotal() * 100);
			if(pctLoaded == 100){
				pBar_mc.swapDepths(100);
				pBar_mc.removeMovieClip();
				loadObj.nextFrame();
			}
			if (!isNaN(pctLoaded)) {
				pBar_mc.bar_mc._xscale = pctLoaded;
				pBar_mc.label_txt.text = pctLoaded + "% loaded";
				if (pctLoaded >= 100) {
					pBar_mc.onEnterFrame = undefined;
				}
			}
		}
	}
	/*
	static function createScroller(scrolled:MovieClip, vertical:Boolean, p:MovieClip, x:Number, y:Number):HSScroll{
		p.createEmptyMovieClip("scrollbkg", p.getNextHighestDepth());
		p.scrollbkg.attachMovie("scrollbkg", "scrollbkg", p.getNextHighestDepth());
		p.createEmptyMovieClip("scroller", p.getNextHighestDepth());
		p.scrollbkg.attachMovie("scroller", "scroller", p.getNextHighestDepth());
		p.scrollbkg._x = x;
		p.scroller._x = x;
		p.scrollbkg._x = y;
		p.scroller._x = y;
	}
	*/
	static function initListBtn(btn:MovieClip, p:ListBtn){
		btn.onRelease = function(){
			if(!p.sel){
				this.gotoAndStop("selected");
				p.sel = true;
			}else{
				this.gotoAndStop("unselected");
				p.sel = false;
			}
			
		}
		
		btn.onRollOver = function(){this.gotoAndStop("over");}
		btn.onRollOver = function(){this.gotoAndStop("start");}
	}
	
	static function initListExt(l:ListExt){
		l.execute_btn.onRelease = function(){
			l.pObj.onListSelect();
		}
	}
	
}