﻿import reefling.classes.util.*
class AdvSurf extends Surf{
	
	var advObjRef:AdvObj;
	
	function AdvSurf(m:MovieClip, stX:Number, stY:Number, e:Number, sp:Number, minAng:Number, maxAng:Number){
		super(m, stX, stY, e, sp, minAng, maxAng);
	}
	
	//resets the surf, happens if the target movie is being dragged
	function reset(){
		this.oPoint.movieSet(this.movie);
		this.cPoint.set(0,0);
		this.angle.set(0,0);
		this.cSpeed.set(this.speed,this.speed);
		this.cStrength.set(0,0);
	}
	
	function connectToAdvObj(o:AdvObj){
		this.advObjRef = o;
	}
	
	function move(){
		//if the movie is not being dragged, translate it, otherwise reset it
		if(!this.movie.handleDrag){
			//if the angle is bigger than one revolution or zero, start a new surf 
			//all surfs will be different
			if(this.angle.x > Math.abs(HSMath.PItimes2) || this.angle.x == 0){
				this.angle.x = 0;
				this.cStrength.x = this.strength.x + (Math.random() * this.eccentricity);
				this.cSpeed.x = this.speed * (Math.random()*this.eccentricity);
				//if(Math.random() < 0.5)
					//this.cSpeed.x = -this.cSpeed.x;
			}
			
			//
			if(this.angle.y > Math.abs(HSMath.PItimes2) || this.angle.y == 0){
				this.angle.y = 0;
				this.cStrength.y = this.strength.y + (Math.random() * this.eccentricity);
				this.cSpeed.y = this.speed * (Math.random()*this.eccentricity);
			}
			
			//first the angle is being increased by the speed
			this.angle.y += HSMath.HSRAD * this.cSpeed.y;
			this.angle.x += HSMath.HSRAD * this.cSpeed.x;
			//then the controlpoint is being translated with the angle and the amplitude
			this.cPoint.y = Math.sin(this.angle.y) * this.cStrength.y;
			this.cPoint.x = Math.sin(this.angle.x) * this.cStrength.x;
			//lastly the movie is being translated relative to the original point
			this.advObjRef.moveCurrAbs(cPoint);

		}else 
			this.reset();
	}
}