﻿import reefling.classes.util.*
class Animal extends Obj{
	
	//var aniFlag:Boolean;
	var cPoint:V2D;
	//var freq:Number;
	var angle:Number;
	var speed:Number;
	var ecc:Number;
	var parentClip:MovieClip;
	var Mod1:Number;
	var out:Boolean;
	
	function Animal(movie:MovieClip, p:MovieClip, freq:Number, ecc:Number, sp:Number, angle:Number, id:String){
		super(id, movie);
		this.cPoint = new V2D(movie._x, movie._y);
		//this.aniFlag  = false;
		//this.freq 	  = freq;
		this.ecc 	  = ecc;
		this.speed	  = sp;
		this.angle	  = angle;
		this.parentClip = p;
		//this.clip.cacheAsBitmap = true;
		this.Mod1 = 0.005;
		this.out = false;
		if(this.angle > HSMath.PIthru2 && this.angle < HSMath.PIthru2times3)
			this.clip._yscale = -100;
	}
	
	function moveMe(){
		if(!this.clip.handleDrag){
			this.cPoint.incScals(Math.cos(this.angle) * this.speed, Math.sin(this.angle) * this.speed);
			this.cPoint.moveMovie(this.clip);
			this.clip._rotation = HSMath.HSDEG * this.angle;
			this.changeAngle();
			if(!this.parentClip.hitTest(this.clip)){
				this.handleOut();
				//trace(this.clip._x+" "+this.clip._y+" "+this.angle);
			}
		}else{
			this.cPoint.movieSet(this.clip);
		}
	}
	
	function handleOut(){
		if(this.clip._x < 0){
			//trace(this.angle);
			if(this.angle < Math.PI && this.angle > HSMath.PIthru2)
				this.angle = Math.PI - this.angle;
			else if(this.angle > Math.PI && this.angle < HSMath.PIthru2times3)
				this.angle = HSMath.PItimes2-(this.angle-Math.PI);
			
			this.clip._yscale = Math.abs(this.clip._yscale);
			
		} else if(this.clip._x > this.parentClip._width){
			if(this.angle < (HSMath.PIthru2))
				this.angle = Math.PI - this.angle;
			else if(this.angle > HSMath.PIthru2times3)
				this.angle = Math.PI+(HSMath.PItimes2-this.angle);
				
			this.clip._yscale = -100;
		}
		
		//the coordinate system is turned upside down, therefore we use inverse angles
		if(this.clip._y < 0){
			if(this.angle > Math.PI)
				this.angle = HSMath.PItimes2 - this.angle;
		}else if(this.clip._y > this.parentClip._height){
			if(this.angle < Math.PI)
				this.angle = HSMath.PItimes2 - this.angle;
		}
	}
	
	function redrawMe(id:String){
		this.clip.removeMovieClip();
		//p.createEmptyMovieClip(this.id, p.getNextHighestDepth());
		this.clip.attachMovie(id, this.id, this.clip.getDepth());

	}
	
	function changeAngle(){
		if(Math.random() < this.ecc){
			if(Math.random() * 10000 < 5000)
				this.angle -= Math.random() * this.Mod1;
			else
				this.angle += Math.random() * this.Mod1;
		}
	}
}