﻿import util.*
class Bubbles{
	
	var startPos:V2D;				//startposition for the bubbles
	var cPos:V2D;					//current position for the bubbles
	var spread:Number;				//spread in x dim.
	var speed:Number;				//general speed of the bubbles
	var ecc:Number;				//chaoticity
	var pClip:MovieClip;			//parent movieclip
	var oriDim:V2D;					//original dimensions of the bubbles
	var freq:Number;				//controls the frequency of breathing
	var breatheInFlag:Boolean;		//controls the breathing
	var breathing:Sound;			//the breath sound
	var arr:Array;					//array for the bubbles
	
	function Bubbles(id:String, namn:String, f:Number, sX:Number, sY:Number, spr:Number, s:Number, e:Number, p:MovieClip, n:Number){
		this.startPos 	= new V2D(sX, sY);
		this.cPos		= new V2D(sX, sY);
		this.spread 	= spr;
		this.speed 		= s;
		this.ecc 		= e;
		this.pClip 		= p;
		this.freq		= f;
		this.breatheInFlag = true; 
		this.arr		= new Array(n);
		this.drawAll(id, namn, p);
		this.oriDim 	= new V2D(this.arr[0].clip._width, this.arr[0].clip._height);
		this.reset();
	}
	
	//puts all the objects on stage
	public function drawAll(id:String, namn:String, p:MovieClip){
		for(var i:Number = 0; i < this.arr.length; i++){
			p.createEmptyMovieClip(namn+i, p.getNextHighestDepth());
			//trace(id + ' '+ namn + ' ' + i);
			
			var temp:Bubble = new Bubble(id, p[namn+i]);
			this.arr[i] = temp;
			this.arr[i].clip.attachMovie(this.arr[i].id, namn+i, p.getNextHighestDepth());
			//this.arr[i].clip.cacheAsBitmap = true;
		}
	}
	
	/*updates the bubbles, if a breath is supposed to be taken, the frequency will control when the sound
	starts, the sound has to be set to set the flag to false when it ends in the onsoundcomplete callback
	function*///*
	function update(t:Number){
		if(this.breatheInFlag){
			if(t % this.freq == 0){
				this.breathing.start(0,1);
			}
		}else
			this.move();
	}
	
	//moves the bubbles, the xdim-translation will be oscillatory, the ydim will depend on the speed of the
	//container and a random value for each bubble
	function move(){
		this.moveAll(0, -this.speed);
		for(var i:Number = 0; i < this.arr.length; i++){
			this.arr[i].ang += HSMath.HSRAD * this.arr[i].angSpd;
			this.arr[i].clip._x = this.arr[i].startPosX + (this.arr[i].xStr * Math.cos(this.arr[i].ang));
			this.arr[i].clip._y += this.arr[i].ySpd;
		}
		
		//if all the bubbels have passed off the screen we reset them
		if(this.cPos.y < 0){
			if(this.testOut(true)){
				this.reset();
				this.breatheInFlag = true;
			}
		}
	}
	
	//moves the bubbles and the current position, the cPos becomes a sort of mean bubble-value
	function moveAll(x:Number, y:Number){
		this.cPos.incScals(x, y);
		for(var i:Number = 0; i < this.arr.length; i++){
			this.arr[i].incPos(x, y);
		}
	}
	
	//checks to see if all the bubbles have reached endposition offscreen
	function testOut(above:Boolean):Boolean{
		if(above){
			for(var i:Number = 0; i < this.arr.length; i++){
				if(this.arr[i].clip._y > -this.arr[i].clip._height)
					return false;
			}
		}else{
			for(var i:Number = 0; i < this.arr.length; i++){
				if(this.arr[i].clip._y < this.pClip._height + this.arr[i].clip._height)
					return false;
			}
		}
			
		return true;
	}
	
	//resets all the values in preparation of next breath, 
	//lots of randomness involved to create different bubbles every breath
	function reset(){
		for(var i:Number = 0; i < this.arr.length; i++){
			this.cPos.setVpos(this.startPos);
			this.arr[i].setVpos(this.startPos);
			this.arr[i].scaleSet(this.oriDim.x, this.oriDim.y);
			this.arr[i].angSpd = Math.random() * this.ecc;
			this.arr[i].ang = Math.random() * HSMath.PItimes2;
			this.arr[i].xStr = Math.random() * this.ecc * 2;
			this.arr[i].ySpd = -(Math.random() * this.ecc * 0.5);
			this.arr[i].scaleInc(-this.arr[i].ySpd*10);
			this.arr[i].incPos(HSMath.negaPosi(spread)*Math.random(), 0);
			this.arr[i].startPosX = this.arr[i].clip._x;
			//this.arr[i].clip.graphics_mc.gotoAndPlay(int(Math.random()*30));
		}
	}
}