﻿class AdvObj extends Obj{
	
	var ctrlPoint:V2D;		//the controlpoint wchich will control the basic position
	//if the object is subjected to changes which require absolute positioning the current point is used
	//for positioning the movieclip
	var curPoint:V2D;	
	var angle:Number;		//the angle to use in case of rotational changes
	
	//initially both the controlpoint and the current point gets values from the movieclip representation
	function AdvObj(movie:MovieClip, id:String){
		super(id, movie);
		this.ctrlPoint 	= new V2D(this.clip._x, this.clip._y);
		this.curPoint 	= new V2D(this.clip._x, this.clip._y);
		this.angle 		= 0;
	}
	
	//the current point is used for positioning of the movieclip
	function drawMe(){
		this.curPoint.moveMovie(this.clip);
	}
	
	//simple translation
	function moveMe(inc:V2D){
		this.ctrlPoint.inc(inc);
		this.curPoint.inc(inc);
	}
	
	function moveCurrAbs(inc:V2D){
		this.curPoint.x = this.ctrlPoint.x + inc.x;
		this.curPoint.y = this.ctrlPoint.y + inc.y;
	}
	
	//if the object will jump to new position the current point will keep same relative position
	function setMe(pos:V2D){
		var temp:V2D = HSMath.d2dif(this.ctrlPoint, this.curPoint);
		this.ctrlPoint.setVpos(pos);
		this.curPoint = new V2D(this.ctrlPoint.x + temp.x, this.ctrlPoint.y + temp.y);
	}
	
	//rotation of the movieclip
	function rotate(){
		this.clip._rotation = this.angle * HSMath.HSDEG;
	}
}