﻿class HSMath {
	
	static var HSRAD:Number = 0.017453293;
	static var HSDEG:Number = 57.29577951;
	static var PIthru2:Number = Math.PI/2;
	static var PIthru2times3:Number = Math.PI * 1.5;
	static var PItimes2:Number = Math.PI*2;
	static var limit:Number = 200;
	//static var ORIGO:hsPoint = new hsPoint(0, 0, 0);
	
	static function d2dif(P1:V2D, P2:V2D):V2D{
		var temp:V2D = new V2D(P2.x-P1.x, P2.y-P1.y);
		return temp;
	}
	
	static function make_neg(n:Number):Number{
		if(n > 0)
			return -n;
		
		return n;
	}
	
	static function d2divideRange(P1:V2D, P2:V2D):Number{
		return (P2.y - P2.x) / (P1.y - P1.x);
	}
	
	static function getNegPos(n:Number):Number{
		if(n < 0)
			return -1;
		else if(n > 0)
			return 1;
			
		return 0;
	}
	
	static function setToLimit(v:Number, l:Number):Number{
		if(v > l)
			return l;
		
		if(v < -l)
			return -l;
			
		return v;
	}
	
	static function upToZero(v:Number):Number{
		if(v < 0)
			return 0;
		else
			return v;
	}
	
	static function convertAngle(startAngle:Number, angle:Number):Number{
		angle *= HSMath.HSDEG;
		angle = HSMath.continuousAngle(angle);
		angle -= startAngle;
		return angle;
	}
	
	static function continuousAngle(angle:Number):Number{
		if (angle < 0)
			angle += 180;
			
		return angle;
	}
	
	static function d2abs(P1:V2D, P2:V2D):Number{
		var temp:V2D = HSMath.d2dif(P1, P2);
		return Math.sqrt(Math.pow(temp.x, 2) + Math.pow(temp.y, 2));
	}
	
	static function negaPosi(n:Number):Number{
		if(Math.random() < 0.5)
			return -n;
			
		return n;
	}
	
	static function generateCode(n:Number):String{
		var temp:String = new String("abcdefghijklmnopqrstuvxyz0123456789");
		var code:String = "";
		for(var i:Number = 0; i < n; i++){
			code += temp.charAt(int(Math.random()*temp.length));
		}
		
		return code;
		
	}
	/*
	//räknar ut absolutavståndet i 3D mellan två punkter
	static function hs3Dabs(P1:v3D, P2:v3D):Number{
		//vi räknar ut skillnaden
		var t1:v3D = hs3DDifPoint(P1, P2);
		var t2:Number = Math.sqrt(Math.pow(t1.x, 2) + Math.pow(t1.y, 2) + Math.pow(t1.z, 2));
		return t2;
	}
	
	//räknar ut absolutavståndet i 2D mellan två punkter
	static function hs2Dabs(P1:v3D, P2:v3D, dimType:String):Number{
		//vi räknar ut skillnaden
		var t1:v3D = hs3DDifPoint(P1, P2);
		
		if(dimType == "xy")
			var t2:Number = Math.sqrt(Math.pow(t1.x, 2) + Math.pow(t1.y, 2));
			
		if(dimType == "xz")
			var t2:Number = Math.sqrt(Math.pow(t1.x, 2) + Math.pow(t1.z, 2));
			
		if(dimType == "yz")
			var t2:Number = Math.sqrt(Math.pow(t1.y, 2) + Math.pow(t1.z, 2));
			
		return t2;
	}
	
	static function pointPlaneDist3D(po:v3D, pl:hsPlane):Number{
		return Math.abs((pl.a*po.x) + (pl.b*po.y) + (pl.c*po.z) + pl.d) / 
			   Math.sqrt(Math.pow(pl.a,2) + Math.pow(pl.b,2) + Math.pow(pl.c,2));
	}
	

	//returnerar skillnaden mellan två vektorer
	static function hs3DDifPoint(P1:v3D, P2:v3D):v3D{
		var temp:v3D = new hsPoint(P2.x-P1.x, P2.y-P1.y, P2.z-P1.z);
		return temp;
	}
	
	//returnerar skalärprodukten
	hsDotProduct(u:v3D, v:v3D):Number{
		return u.x*v.x + u.y*v.y + u.z*v.z;
	}
	*/
}