﻿class VirtualCamera extends AdvObj{
	
	var pClip:MovieClip;		//the parent clip
	var lockedOn:Boolean;		//is the camera locked on to something?
	var toFollow:AdvObj;		//the object to follow if locked
	var scaleFactor:V2D;		//the amount to scale the camera in order for it to fit on stage
	
	function VirtualCamera(movie:MovieClip, id:String, parent:MovieClip){
		super(movie, id);
		//this.clip._visible = false;
		Stage.scaleMode = "exactFit";	//distortions are allowed to occur
		this.pClip = parent;
		this.scaleFactor = new V2D(Stage.width / this.clip._width, Stage.height / this.clip._height);
		//the parent movieclip is scaled so it will show the right amount of zoom
		this.pClip._xscale *= this.scaleFactor.x;
		this.pClip._yscale *= this.scaleFactor.y;
	}
	
	function lockOnTo(obj:AdvObj){
		this.toFollow = obj;
		this.lockedOn = true;
	}
	
	function drawMe(){
		if(lockedOn){
			//we follow the controlpoint which disallows the camera to follow potential erratic movement
			this.ctrlPoint.setVpos(this.toFollow.ctrlPoint);
			this.curPoint.setVpos(this.toFollow.ctrlPoint);

		}
		
		super.drawMe();
		//the parent clip is translated first to the middle of the stage then in opposite direction
		//to the camera to simulate a moving camera
		this.pClip._x = (Stage.width/2) - (this.clip._x * this.scaleFactor.x);
		this.pClip._y = (Stage.height/2) - (this.clip._y * this.scaleFactor.y);
		//this.pClip._rotation = this.clip._rotation;
	}
}